classdef ESC_System
    %ESC_SYSTEM Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        P
        Pmin 
        Pmax 
        Vb
    end
    
    methods
        function obj = ESC_System(P, Pmin, Pmax, Vb)
            %ESC_SYSTEM Construct an instance of this class
            %   Detailed explanation goes here
            obj.P = P;
            obj.Pmin = Pmin;
            obj.Pmax = Pmax;
            obj.Vb = Vb;
        end
        
        function Vb_eff   = ESC(obj)
            P1 = obj.P(1);
            P2 = obj.P(2);
            P3 = obj.P(3);
            P4 = obj.P(4);
            
            % Define u_Pi for each of the rotors, limiting it to be greater than 0
            u_P0 = (P1 - obj.Pmin) / (obj.Pmax - obj.Pmin);
            u_P1 = (P2 - obj.Pmin) / (obj.Pmax - obj.Pmin);
            u_P2 = (P3 - obj.Pmin) / (obj.Pmax - obj.Pmin);
            u_P3 = (P4 - obj.Pmin) / (obj.Pmax - obj.Pmin);
            
            
            % Determine the effective battery voltage from each ESC
            Vb_eff_0 = u_P0 * obj.Vb;
            Vb_eff_1 = u_P1 * obj.Vb;
            Vb_eff_2 = u_P2 * obj.Vb;
            Vb_eff_3 = u_P3 * obj.Vb;
                
            Vb_eff = [Vb_eff_0, Vb_eff_1, Vb_eff_2, Vb_eff_3];            
        end
    end
end

